%global __brp_remove_la_files %nil
%global __provides_exclude_from ^%{_libdir}/GraphicsMagick-%{version}/.*\\.(la|so)$
%global urw_font_path %{_datadir}/GraphicsMagick-%{version}/urw-fonts

Summary:   An ImageMagick fork, offering faster image generation and better quality
Name:      GraphicsMagick
Version:   1.3.40
Release:   8%{?dist}
License:   MIT
Url:       http://www.graphicsmagick.org/
Source0:   http://downloads.sourceforge.net/sourceforge/graphicsmagick/GraphicsMagick-%{version}.tar.xz
Source1:   https://distfiles.macports.org/urw-fonts/urw-fonts-1.0.7pre44.tar.bz2

# https://hg.osdn.net/view/graphicsmagick/GM/rev/c6b81acd69bd
Patch0001: GraphicsMagick-1.3.40-correct-strlcpy-length-arguments.patch
Patch3000: GraphicsMagick-1.3.16-multilib.patch
Patch3001: GraphicsMagick-1.3.31-perl_linkage.patch

BuildRequires: bzip2-devel freetype-devel gcc-c++ giflib-devel jasper-devel lcms2-devel libjpeg-devel libpng-devel
BuildRequires: librsvg2-devel libtiff-devel libtool-ltdl-devel libwmf-devel libxml2-devel libX11-devel
BuildRequires: libXext-devel libXt-devel lpr make perl-devel perl-generators perl(ExtUtils::MakeMaker) xdg-utils
BuildRequires: xz-devel zlib-devel time jbigkit-devel libwebp-devel

Provides: %{name}-doc = %{version}-%{release}

%description
GraphicsMagick is a comprehensive image processing package which is initially based on ImageMagick
5.5.2, but which has undergone significant re-work by the GraphicsMagick Group to significantly
improve the quality and performance of the software.

%package devel
Summary: Libraries and header files for GraphicsMagick app development
Requires: %{name} = %{version}-%{release}

%description devel
GraphicsMagick-devel contains the Libraries and header files you'll need to develop GraphicsMagick
applications. GraphicsMagick is an image manipulation program.

If you want to create applications that will use GraphicsMagick code or APIs, you need to install
GraphicsMagick-devel as well as GraphicsMagick.  You do not need to install it if you just want to
use GraphicsMagick, however.

%package perl
Summary: GraphicsMagick perl bindings
Requires: %{name} = %{version}-%{release}

%description perl
Perl bindings to GraphicsMagick.

Install GraphicsMagick-perl if you want to use any perl scripts that use GraphicsMagick.

%package c++
Summary: GraphicsMagick Magick++ library (C++ bindings)
Requires: %{name} = %{version}-%{release}

%description c++
This package contains the GraphicsMagick++ library, a C++ binding to the GraphicsMagick graphics
manipulation library.

Install GraphicsMagick-c++ if you want to use any applications that use GraphicsMagick++.

%package c++-devel
Summary: C++ bindings for the GraphicsMagick library
Requires: %{name}-c++ = %{version}-%{release}
Requires: %{name}-devel = %{version}-%{release}

%description c++-devel
GraphicsMagick-devel contains the Libraries and header files you'll need to develop GraphicsMagick
applications using the Magick++ C++ bindings.  GraphicsMagick is an image manipulation program.

If you want to create applications that will use Magick++ code or APIs, you'll need to install
GraphicsMagick-c++-devel, ImageMagick-devel and GraphicsMagick.  You don't need to install it if you
just want to use GraphicsMagick, or if you want to develop/compile applications using the
GraphicsMagick C interface, however.

%prep
%autosetup -n %{name}-%{version} -p1

mkdir -p urw-fonts
tar --directory=urw-fonts/ -xf %{SOURCE1}
rm -f urw-fonts/ChangeLog urw-fonts/README* urw-fonts/fonts*

for f in ChangeLog.{2006,2008,2009,2012} NEWS.txt ; do
    iconv -f iso-8859-2 -t utf8 < $f > $f.utf8
    touch -r $f $f.utf8 ; mv -f $f.utf8 $f
done

sed -i.rpath -e 's|"/lib /usr/lib|"/%{_lib} %{_libdir}|' configure

%build
%configure \
    --enable-shared --disable-static \
    --docdir=%{_pkgdocdir} \
    --with-lcms2 \
    --with-magick_plus_plus \
    --with-modules \
    --with-perl \
    --with-perl-options="INSTALLDIRS=vendor %{?perl_prefix}" \
    --with-quantum-depth=16 \
    --enable-quantum-library-names \
    --with-threads \
    --with-wmf \
    --with-x \
    --with-xml \
    --without-dps \
    --without-gslib \
    --with-gs-font-dir=%{urw_font_path} \
    %{nil}

%make_build
%make_build perl-build

%install
%make_install
%make_install -C PerlMagick

%{__perl} -MExtUtils::MakeMaker -e 'MY->fixin(@ARGV)' PerlMagick/demo/*.pl

find %{buildroot} -name "*.bs" |xargs rm -fv
find %{buildroot} -name ".packlist" |xargs rm -fv
find %{buildroot} -name "perllocal.pod" |xargs rm -fv

ls -l %{buildroot}%{perl_vendorarch}/auto/Graphics/Magick/Magick.so
chmod 755 %{buildroot}%{perl_vendorarch}/auto/Graphics/Magick/Magick.so

find %{buildroot}/%{_libdir}/perl* -type f -print \
    | sed "s@^%{buildroot}@@g" > perl-pkg-files 
find %{buildroot}%{perl_vendorarch} -type d -print \
    | sed "s@^%{buildroot}@%dir @g" \
    | grep -v '^%dir %{perl_vendorarch}$' \
    | grep -v '/auto$' >> perl-pkg-files 
if [ -z perl-pkg-files ] ; then
    echo "ERROR: EMPTY FILE LIST"
    exit -1
fi

rm -rfv %{buildroot}%{_datadir}/GraphicsMagick
rm -rfv %{buildroot}%{_datadir}/%{name}-%{version}/[a-b,d-z,A-Z]*
rm -fv  %{buildroot}%{_libdir}/lib*.la

mkdir -p %{buildroot}%{urw_font_path}/
install -p -m644 urw-fonts/* %{buildroot}%{urw_font_path}/

%check
make test -C PerlMagick ||:
time %make_build check

%files
%license %{_pkgdocdir}/Copyright.txt
%dir %{_pkgdocdir}
%{_libdir}/libGraphicsMagick-Q16.so.3*
%{_libdir}/libGraphicsMagickWand-Q16.so.2*
%{_bindir}/[a-z]*
%{_libdir}/GraphicsMagick-%{version}/
%{_datadir}/GraphicsMagick-%{version}/
%dir %{_pkgdocdir}
%{_pkgdocdir}/ChangeLog*
%{_pkgdocdir}/*.txt
%{_pkgdocdir}/www/
%{_mandir}/man[145]/[a-z]*

%files devel
%{_bindir}/GraphicsMagick-config
%{_bindir}/GraphicsMagickWand-config
%{_libdir}/libGraphicsMagick.so
%{_libdir}/libGraphicsMagickWand.so
%{_libdir}/pkgconfig/GraphicsMagick.pc
%{_libdir}/pkgconfig/GraphicsMagickWand.pc
%dir %{_includedir}/GraphicsMagick/
%{_includedir}/GraphicsMagick/magick/
%{_includedir}/GraphicsMagick/wand/
%{_mandir}/man1/GraphicsMagick-config.*
%{_mandir}/man1/GraphicsMagickWand-config.*

%files c++
%{_libdir}/libGraphicsMagick++-Q16.so.12*

%files c++-devel
%{_bindir}/GraphicsMagick++-config
%{_includedir}/GraphicsMagick/Magick++/
%{_includedir}/GraphicsMagick/Magick++.h
%{_libdir}/libGraphicsMagick++.so
%{_libdir}/pkgconfig/GraphicsMagick++.pc
%{_mandir}/man1/GraphicsMagick++-config.*

%files perl -f perl-pkg-files
%doc PerlMagick/demo/ PerlMagick/Changelog PerlMagick/README.txt
%{_mandir}/man3/*

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.40-8
- Rebuilt for loongarch release

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.40-7
- Rebuilt for OpenCloudOS Stream 23.09

* Mon Sep 04 2023 Miaojun Dong <zoedong@tencent.com> - 1.3.40-6
- Add patch to correct strlcpy() length arguments

* Fri Aug 18 2023 cunshunxia <cunshunxia@tencent.com> - 1.3.40-5
- Rebuilt for jasper-libs 4.0.0

* Fri Aug 18 2023 Wang Guodong <gordonwwang@tencent.com> - 1.3.40-4
- Rebuilt for librsvg2 2.56.90

* Wed Aug 02 2023 kianli <kianli@tencent.com> - 1.3.40-3
- Rebuilt for libtiff 4.5.1

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.3.40-2
- Rebuilt for OpenCloudOS Stream 23.05

* Sun Apr 23 2023 Shuo Wang <abushwang@tencent.com> - 1.3.40-1
- initial build
